Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 9885)
@@ -41,5 +41,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Optimization.Operators;
-using HeuristicLab.ParallelEngine;
 using HeuristicLab.Persistence.Default.Xml;
 using HeuristicLab.Problems.ArtificialAnt;
@@ -61,9 +60,8 @@
 using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
 using HeuristicLab.Selection;
-using HeuristicLab.SequentialEngine;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   [DeploymentItem(@"HeuristicLab-3.3/Resources/C101.opt.txt")]
@@ -73,4 +71,6 @@
     #region TSP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGaTspSampleTest() {
       var ga = CreateGaTspSample();
@@ -78,4 +78,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGaTspSampleTest() {
       var ga = CreateGaTspSample();
@@ -109,4 +111,6 @@
     #region VRP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGaVrpSampleTest() {
       var ga = CreateGaVrpSample();
@@ -115,4 +119,6 @@
 
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGaVrpSampleTest() {
       var ga = CreateGaVrpSample();
@@ -179,4 +185,6 @@
     #region ArtificialAnt
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGpArtificialAntSampleTest() {
       var ga = CreateGpArtificialAntSample();
@@ -185,4 +193,6 @@
 
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGpArtificialAntSampleTest() {
       var ga = CreateGpArtificialAntSample();
@@ -231,4 +241,6 @@
     #region Symbolic Regression
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGpSymbolicRegressionSampleTest() {
       var ga = CreateGpSymbolicRegressionSample();
@@ -236,4 +248,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGpSymbolicRegressionSampleTest() {
       var ga = CreateGpSymbolicRegressionSample();
@@ -335,4 +349,6 @@
     #region Symbolic Classification
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGpSymbolicClassificationSampleTest() {
       var ga = CreateGpSymbolicClassificationSample();
@@ -341,4 +357,6 @@
 
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGpSymbolicClassificationSampleTest() {
       var ga = CreateGpSymbolicClassificationSample();
@@ -442,4 +460,6 @@
     #region LawnMower
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGpLawnMowerSampleTest() {
       var ga = CreateGpLawnMowerSample();
@@ -472,4 +492,6 @@
     #region Griewank
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateEsGriewankSampleTest() {
       var es = CreateEsGriewankSample();
@@ -477,4 +499,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunEsGriewankSampleTest() {
       var es = CreateEsGriewankSample();
@@ -526,4 +550,6 @@
     #region TSP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateIslandGaTspSampleTest() {
       var ga = CreateIslandGaTspSample();
@@ -531,4 +557,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunIslandGaTspSampleTest() {
       var ga = CreateIslandGaTspSample();
@@ -566,4 +594,6 @@
     #region Knapsack
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateLocalSearchKnapsackSampleTest() {
       var ls = CreateLocalSearchKnapsackSample();
@@ -571,4 +601,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "medium")]
     public void RunLocalSearchKnapsackSampleTest() {
       var ls = CreateLocalSearchKnapsackSample();
@@ -618,5 +650,5 @@
       ls.SetSeedRandomly.Value = true;
       #endregion
-      ls.Engine = new ParallelEngine();
+      ls.Engine = new ParallelEngine.ParallelEngine();
       return ls;
     }
@@ -627,4 +659,6 @@
     #region Schwefel
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreatePsoSchwefelSampleTest() {
       var pso = CreatePsoSchwefelSample();
@@ -632,4 +666,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "medium")]
     public void RunPsoSchwefelSampleTest() {
       var pso = CreatePsoSchwefelSample();
@@ -697,5 +733,5 @@
       pso.SetSeedRandomly.Value = true;
       #endregion
-      pso.Engine = new ParallelEngine();
+      pso.Engine = new ParallelEngine.ParallelEngine();
       return pso;
     }
@@ -706,4 +742,6 @@
     #region Rastrigin
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateSimulatedAnnealingRastriginSampleTest() {
       var sa = CreateSimulatedAnnealingRastriginSample();
@@ -711,4 +749,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "medium")]
     public void RunSimulatedAnnealingRastriginSampleTest() {
       var sa = CreateSimulatedAnnealingRastriginSample();
@@ -763,5 +803,5 @@
       sa.StartTemperature.Value = 1;
       #endregion
-      sa.Engine = new ParallelEngine();
+      sa.Engine = new ParallelEngine.ParallelEngine();
       return sa;
     }
@@ -772,4 +812,6 @@
     #region TSP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateTabuSearchTspSampleTest() {
       var ts = CreateTabuSearchTspSample();
@@ -777,4 +819,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunTabuSearchTspSampleTest() {
       var ts = CreateTabuSearchTspSample();
@@ -832,5 +876,5 @@
 
       #endregion
-      ts.Engine = new ParallelEngine();
+      ts.Engine = new ParallelEngine.ParallelEngine();
       return ts;
     }
@@ -839,4 +883,6 @@
     #region VRP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateTabuSearchVRPSampleTest() {
       var vrp = CreateTabuSearchVrpSample();
@@ -844,4 +890,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunTabuSearchVRPSampleTest() {
       var vrp = CreateTabuSearchVrpSample();
@@ -898,5 +946,5 @@
 
       #endregion
-      ts.Engine = new ParallelEngine();
+      ts.Engine = new ParallelEngine.ParallelEngine();
       return ts;
     }
@@ -907,4 +955,6 @@
     #region TSP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateVnsTspSampleTest() {
       var vns = CreateVnsTspSample();
@@ -912,4 +962,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunVnsTspSampleTest() {
       var vns = CreateVnsTspSample();
@@ -976,5 +1028,5 @@
       vns.ShakingOperator = shakingOperator;
       #endregion
-      vns.Engine = new ParallelEngine();
+      vns.Engine = new ParallelEngine.ParallelEngine();
       return vns;
     }
@@ -984,4 +1036,6 @@
     #region Gaussian Process Regression
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateGaussianProcessRegressionSampleTest() {
       var gpr = CreateGaussianProcessRegressionSample();
@@ -989,4 +1043,6 @@
     }
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunGaussianProcessRegressionSample() {
       var gpr = CreateGaussianProcessRegressionSample();
@@ -1015,5 +1071,5 @@
       gpr.SetSeedRandomly = true;
       #endregion
-      gpr.Engine = new ParallelEngine();
+      gpr.Engine = new ParallelEngine.ParallelEngine();
       return gpr;
     }
@@ -1023,4 +1079,6 @@
     #region VRP
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateScatterSearchVRPSampleTest() {
       var ss = CreateScatterSearchVRPSample();
@@ -1029,4 +1087,6 @@
 
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunScatterSearchVRPSampleTest() {
       var ss = CreateScatterSearchVRPSample();
@@ -1049,5 +1109,5 @@
       #region Algorithm Configuration
       ScatterSearch ss = new ScatterSearch();
-      ss.Engine = new SequentialEngine();
+      ss.Engine = new SequentialEngine.SequentialEngine();
       ss.Name = "Scatter Search - VRP";
       ss.Description = "A scatter search algorithm which solves the \"C101\" vehicle routing problem (imported from Solomon)";
@@ -1079,4 +1139,6 @@
     #region Scheduling
     [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
     public void CreateRAPGASchedulingSampleTest() {
       var ss = CreateRAPGASchedulingSample();
@@ -1085,4 +1147,6 @@
 
     [TestMethod]
+    [TestCategory("Samples.Execute")]
+    [TestProperty("Time", "long")]
     public void RunRAPGASchedulingSampleTest() {
       var rapga = CreateRAPGASchedulingSample();
@@ -1102,5 +1166,5 @@
       #region Algorithm Configuration
       RAPGA rapga = new RAPGA();
-      rapga.Engine = new SequentialEngine();
+      rapga.Engine = new SequentialEngine.SequentialEngine();
       rapga.Name = "RAPGA - Job Shop Scheduling";
       rapga.Description = "A relevant alleles preserving genetic algorithm which solves a job shop scheduling problem";
@@ -1147,5 +1211,5 @@
         .OfType<SM>()
         .Single();
-      es.Engine = new ParallelEngine();
+      es.Engine = new ParallelEngine.ParallelEngine();
     }
 
@@ -1176,5 +1240,5 @@
         tSelector.GroupSizeParameter.Value.Value = tournGroupSize;
       }
-      ga.Engine = new ParallelEngine();
+      ga.Engine = new ParallelEngine.ParallelEngine();
     }
 
@@ -1215,5 +1279,5 @@
         .OfType<MiR>()
         .Single();
-      ga.Engine = new ParallelEngine();
+      ga.Engine = new ParallelEngine.ParallelEngine();
     }
 
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/StorableConstructorTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/StorableConstructorTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/StorableConstructorTest.cs	(revision 9885)
@@ -30,5 +30,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class StorableConstructorTest {
@@ -41,4 +41,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "short")]
     public void TestStorableConstructor() {
       StringBuilder errorMessage = new StringBuilder();
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/ThreadSafeLogTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/ThreadSafeLogTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/ThreadSafeLogTest.cs	(revision 9885)
@@ -25,9 +25,11 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class ThreadSafeLogTest {
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "short")]
     public void ThreadSafeLogThreadSafetyTest() {
       int count = 10000;
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/ToStringTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/ToStringTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/ToStringTest.cs	(revision 9885)
@@ -26,20 +26,12 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class ToStringTest {
 
     private TestContext testContextInstance;
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
     public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
+      get { return testContextInstance; }
+      set { testContextInstance = value; }
     }
 
@@ -51,4 +43,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
     public void TestToString() {
       bool success = true;
Index: /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessFunctionsTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessFunctionsTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessFunctionsTest.cs	(revision 9885)
@@ -24,5 +24,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Algorithms.DataAnalysis_34.Tests {
+namespace HeuristicLab.Algorithms.DataAnalysis.Tests {
   [TestClass]
 
@@ -30,4 +30,6 @@
   public class GaussianProcessFunctionsTest {
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void MeanConstTest() {
       TestMeanFunction(new MeanConst(), 0,
@@ -42,4 +44,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void MeanZeroTest() {
       TestMeanFunction(new MeanZero(), 0,
@@ -54,4 +58,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void MeanSumTest() {
       var sum = new MeanSum();
@@ -79,4 +85,6 @@
     }
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void MeanProdTest() {
       var prod = new MeanProduct();
@@ -150,4 +158,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void MeanLinear() {
       TestMeanFunction(new MeanLinear(), 0,
@@ -176,4 +186,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovSeIsoTest() {
       TestCovarianceFunction(new CovarianceSquaredExponentialIso(), 0,
@@ -264,4 +276,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovNnTest() {
       TestCovarianceFunction(new CovarianceNeuralNetwork(), 0,
@@ -353,4 +367,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovRQIsoTest() {
       TestCovarianceFunction(new CovarianceRationalQuadraticIso(), 0,
@@ -466,4 +482,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovRQArdTest() {
       TestCovarianceFunction(new CovarianceRationalQuadraticArd(), 0,
@@ -690,4 +708,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovMaternIsoTest() {
       var cov = new CovarianceMaternIso();
@@ -875,4 +895,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovLinearTest() {
       TestCovarianceFunction(new CovarianceLinear(), 0,
@@ -897,4 +919,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovLinearArdTest() {
       TestCovarianceFunction(new CovarianceLinearArd(), 0,
@@ -1069,4 +1093,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovPeriodicTest() {
       TestCovarianceFunction(new CovariancePeriodic(), 0,
@@ -1187,4 +1213,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovSEardTest() {
       TestCovarianceFunction(new CovarianceSquaredExponentialArd(), 0,
@@ -1384,4 +1412,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovSumTest() {
       var cov = new CovarianceSum();
@@ -1482,4 +1512,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovScaleTest() {
       var cov = new CovarianceScale();
@@ -1604,4 +1636,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void CovProdTest() {
       var cov = new CovarianceProduct();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessModelTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessModelTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessModelTest.cs	(revision 9885)
@@ -21,9 +21,8 @@
 
 using System.Linq;
-using HeuristicLab.Algorithms.DataAnalysis;
 using HeuristicLab.Problems.Instances.DataAnalysis;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Algorithms.DataAnalysis_34.Tests {
+namespace HeuristicLab.Algorithms.DataAnalysis.Tests {
   [TestClass]
 
@@ -32,4 +31,6 @@
     [TestMethod]
     [DeploymentItem(@"HeuristicLab.Algorithms.DataAnalysis-3.4/co2.txt")]
+    [TestCategory("General")]
+    [TestProperty("Time", "medium")]
     public void GaussianProcessModelOutputTest() {
       var provider = new RegressionCSVInstanceProvider();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessRegressionTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessRegressionTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/GaussianProcessRegressionTest.cs	(revision 9885)
@@ -23,5 +23,4 @@
 using System.Linq;
 using System.Threading;
-using HeuristicLab.Algorithms.DataAnalysis;
 using HeuristicLab.Common;
 using HeuristicLab.Problems.DataAnalysis;
@@ -29,5 +28,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Algorithms.DataAnalysis_34.Tests {
+namespace HeuristicLab.Algorithms.DataAnalysis.Tests {
   [TestClass]
   [DeploymentItem(@"HeuristicLab.Algorithms.DataAnalysis-3.4/co2.txt")]
@@ -36,16 +35,7 @@
 
     private TestContext testContextInstance;
-
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
     public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
+      get { return testContextInstance; }
+      set { testContextInstance = value; }
     }
 
@@ -54,4 +44,6 @@
 
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "long")]
     public void GaussianProcessRegressionPerformanceTest() {
       ex = null;
Index: /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/SupportVectorMachineTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/SupportVectorMachineTest.cs	(revision 9885)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/SupportVectorMachineTest.cs	(revision 9885)
@@ -0,0 +1,109 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests {
+  [TestClass]
+  public class SupportVectorMachineTest {
+    public SupportVectorMachineTest() { }
+
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    private EventWaitHandle trigger = new AutoResetEvent(false);
+    private Exception ex;
+
+    [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "medium")]
+    public void SupportVectorMachinePerformanceTest() {
+      ex = null;
+
+      var cv = new CrossValidation();
+      cv.Algorithm = new SupportVectorRegression();
+      var rand = new HeuristicLab.Random.MersenneTwister();
+      double[,] data = GenerateData(1000, rand);
+      List<string> variables = new List<string>() { "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "y" };
+      Dataset ds = new Dataset(variables, data);
+      cv.Problem.ProblemDataParameter.ActualValue = new RegressionProblemData(ds, variables.Take(10), variables.Last());
+      cv.Folds.Value = 5;
+      cv.SamplesStart.Value = 0;
+      cv.SamplesEnd.Value = 999;
+
+      cv.ExceptionOccurred += new EventHandler<EventArgs<Exception>>(cv_ExceptionOccurred);
+      cv.Stopped += new EventHandler(cv_Stopped);
+
+      cv.Prepare();
+      cv.Start();
+      trigger.WaitOne();
+      if (ex != null) throw ex;
+
+      TestContext.WriteLine("Runtime: {0}", cv.ExecutionTime.ToString());
+
+    }
+
+    // poly-10: y = x1 x2 + x3 x4 + x5 x6 + x1 x7 x9 + x3 x6 x10
+    private double[,] GenerateData(int n, IRandom random) {
+      double[,] data = new double[n, 11];
+      for (int i = 0; i < n; i++) {
+        for (int c = 0; c < 10; c++) {
+          data[i, c] = random.NextDouble() * 2.0 - 1.0;
+        }
+        data[i, 10] =
+          data[i, 0] * data[i, 1] +
+          data[i, 2] * data[i, 3] +
+          data[i, 4] * data[i, 5] +
+          data[i, 0] * data[i, 6] * data[i, 8] +
+          data[i, 2] * data[i, 5] * data[i, 9];
+      }
+      return data;
+    }
+
+    private void cv_ExceptionOccurred(object sender, EventArgs<Exception> e) {
+      ex = e.Value;
+    }
+
+    private void cv_Stopped(object sender, EventArgs e) {
+      trigger.Set();
+    }
+  }
+}
Index: /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/MultidimensionalScalingTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/MultidimensionalScalingTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Analysis-3.3/MultidimensionalScalingTest.cs	(revision 9885)
@@ -22,12 +22,13 @@
 using System;
 using System.Globalization;
-using HeuristicLab.Analysis;
 using HeuristicLab.Data;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Analysis_33.Tests {
+namespace HeuristicLab.Analysis.Tests {
   [TestClass]
   public class MultidimensionalScalingTest {
     [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
     public void TestGoodnessOfFit() {
       double stress;
Index: /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalDictionaryTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalDictionaryTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalDictionaryTest.cs	(revision 9885)
@@ -23,8 +23,7 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Collections;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Collections_33.Tests {
+namespace HeuristicLab.Collections.Tests {
   [TestClass]
   public class BidirectionalDictionaryTest {
@@ -46,4 +45,6 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "short")]
     public void TestBidirectionalDictionary() {
       var dict1 = new BidirectionalDictionary<int, double>();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalLookupTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalLookupTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/BidirectionalLookupTest.cs	(revision 9885)
@@ -22,8 +22,7 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Collections;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Collections_33.Tests {
+namespace HeuristicLab.Collections.Tests {
   [TestClass]
   public class BidirectionalLookupTest {
@@ -45,4 +44,6 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "short")]
     public void TestBidirectionalLookup() {
       var lookup1 = new BidirectionalLookup<int, double>();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/ObservableKeyedListTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/ObservableKeyedListTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Collections-3.3/ObservableKeyedListTest.cs	(revision 9885)
@@ -23,8 +23,7 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Collections;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Collections_33.Tests {
+namespace HeuristicLab.Collections.Tests {
   [TestClass]
   public class ObservableKeyedListTest {
@@ -40,4 +39,6 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "short")]
     public void KeyedListAddDuplicateItemTest() {
       var list = new IntKeyedList();
Index: /stable/HeuristicLab.Tests/HeuristicLab.Encodings.BinaryVectorEncoding-3.3/Auxiliary.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Encodings.BinaryVectorEncoding-3.3/Auxiliary.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Encodings.BinaryVectorEncoding-3.3/Auxiliary.cs	(revision 9885)
@@ -20,7 +20,5 @@
 #endregion
 
-using HeuristicLab.Encodings.BinaryVectorEncoding;
-
-namespace HeuristicLab.Encodings.BinaryVectorEncoding_33.Tests {
+namespace HeuristicLab.Encodings.BinaryVectorEncoding.Tests {
   public static class Auxiliary {
     public static bool BinaryVectorIsEqualByPosition(BinaryVector p1, BinaryVector p2) {
